import { Decoder, Encoder, Codec } from "../types";
export declare type ResultPayload<OK, KO> = {
    success: true;
    value: OK;
} | {
    success: false;
    value: KO;
};
export declare const Result: {
    <OK, KO>(okCodec: Codec<OK>, koCodec: Codec<KO>): Codec<ResultPayload<OK, KO>>;
    dec: <OK_1, KO_1>(okDecoder: Decoder<OK_1>, koDecoder: Decoder<KO_1>) => Decoder<ResultPayload<OK_1, KO_1>>;
    enc: <OK_2, KO_2>(okEncoder: Encoder<OK_2>, koEncoder: Encoder<KO_2>) => Encoder<ResultPayload<OK_2, KO_2>>;
};
